<?php
/* Copyright (c) 2009 Arnaud Renevier, Inc, published under the modified BSD
   license. */

require ("./inc/settings.php");
require ("./inc/errors.php");
require ("./inc/db/mysql.php");

function main ($features) {

    echo '<?xml version="1.0" encoding="UTF-8"?>
<kml xmlns="http://www.opengis.net/kml/2.2">
  <Document>
';

    if (SITETITLE) {
        printf ('    <name>%s</name>', SITETITLE);
    }
    foreach ($features as $feature) {
        $title = htmlspecialchars ($feature->title, ENT_QUOTES);
        $description = htmlspecialchars ($feature->description, ENT_QUOTES);
        if (strpos ($feature->imgurl, "http://") === 0) {
            $imgurl = "http://" . rawurlencode (substr($feature->imgurl, 7));
        } else if (strpos ($feature->imgurl, "https://") === 0) {
            $imgurl = "https://" . rawurlencode (substr ($feature->imgurl, 8));
        } else {
            $imgurl = rawurlencode ($feature->imgurl);
        }
        $imgurl = str_replace ('%2F', '/', $imgurl);
        $lon = $feature->lon;
        $lat = $feature->lat;
        $alt = (strlen ($title) > 60) ?
                    (substr ($title, 0, 57) . '...') :
                    $title;

        printf ('
        <Placemark>
            <name>%s</name>
            <description><![CDATA[
                <p>%s</p>
                <img alt="%s" src="%s">
            ]]></description>
            <Point>
                <coordinates>%s,%s</coordinates>
            </Point>
        </Placemark>
', $title, $description, $alt, $imgurl, $lon, $lat);
    }

    echo' </Document>
    </kml>';
}

try {
    $connection->connect (DBHOST, DBUSER, DBPWD, DBNAME, DBPREFIX);
    $features = $connection->listfeatures ();
} catch (Exception $e) {
    server_error ();
}
header ("Content-type: application/vnd.google-earth.kml+xml");
main ($features);
?>
