<?php
/* Copyright (c) 2009 Arnaud Renevier, Inc, published under the modified BSD
   license. */
?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
       "http://www.w3.org/TR/html4/loose.dtd">  
<html>
<head>
      <meta http-equiv="Content-Type" content="text/html; charset=UTF-8" >
      <link rel="stylesheet" href="./media/common.css" type="text/css" />
      <title>SYP wizard</title>
</head>
<body>

<?php
    function wiz_success ($message) {
        printf ("<p class=\"success center\">%s</p>", $message);
    }
    function wiz_error ($message) {
        exit (sprintf ("<p class=\"error center\">%s</p>", $message));
    }
    function wiz_warn ($message) {
        printf ("<p class=\"warn center\">%s</p>", $message);
    }

    if (version_compare (PHP_VERSION, '5.0.0', '<')) {
        wiz_error ("Vous devez utiliser une version de PHP au moins égale à la version 5");
    }

    if (!function_exists ("exif_read_data")) {
        wiz_warn ("Cette version de php ne supporte pas la lecture des données exif");
    }

    require("./inc/settings.php");
    require("./inc/db/mysql.php");

    try {
        $connection->connect (DBHOST, DBUSER, DBPWD, DBNAME, DBPREFIX);
    } catch (Exception $e) {
        switch ($e->getMessage ()) {
            case anydbConnection::err_driver_unavailable:
                wiz_error ('Support de ' . $connection->getdbname () . ' non détecté.');
            case anydbConnection::err_connection:
                wiz_error ('Impossible de se connecter à la base de donnée.');
            case anydbConnection::err_unknown_database:
                wiz_error ('La base de donnée n\'existe pas.');
            default:
                wiz_error ('Erreur inconnue lors de la connexion à la base.');
        }
    }
    try {
        $users_table_exists = $connection->users_table_exists ();
    } catch(Exception $e) {
        wiz_error ('Erreur inconnue lors de la vérification de la table utilisateur.');
    }

    if ($users_table_exists) {
        wiz_success ('Table utilisateur trouvée.');
    } else {
        try {
            $connection->create_users_table (true);
        } catch (Exception $e) {
            wiz_error ('Erreur lors de la création de la table utilisateur.');
        }
        wiz_success ('Table utilisateur crée.');
        try {
            $connection->setpwd ("admin", ADMINPWD);
        } catch (Exception $e) {
            wiz_error ('Erreur lors de l\'initialisation du mot de passe.');
        }
        wiz_success ('Mot de passe administrateur initialisé.');
    }

    try {
        $items_table_exists = $connection->items_table_exists ();
    } catch (Exception $e) {
        wiz_error ('Erreur inconnue lors de la vérification de la table des données.');
    }
    if ($items_table_exists) {
        wiz_success ('Table utilisateur trouvée.');
    } else {
        try {
            $connection->create_items_table (true);
        } catch (Exception $e) {
            wiz_error ('Erreur lors de la création de la table des données.');
        }
        wiz_success ('Table des données crée.');
    }
    if (!is_dir (UPLOADDIR)) {
        if (file_exists (UPLOADDIR)) {
            wiz_error (sprintf ("%s existe et n'est pas un répertoire.",
                                UPLOADDIR));
        }
        if (!mkdir (UPLOADDIR)) {
            wiz_error (sprintf ("Impossible de créer le répertoire %s.",
                                UPLOADDIR));
        } else {
            wiz_success (sprintf ('Répertoire %s crée.', UPLOADDIR));
        }
    }
    if (!is_writeable (UPLOADDIR) || !is_executable (UPLOADDIR)) {
        wiz_error (sprintf ("Impossible d'écrire dans %s.", UPLOADDIR));
    }
    wiz_success ('SYP est installé. Vous pouvez maintenant vous rendre dans <a href="admin.php">la partie administration.');
?>

</body>
</html>
